/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PADSERVICO                                               */
/* Tabela : PADSERVICO                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 13/10/2003 Mariana Costa                                                   */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PADSERVICO
BEFORE INSERT OR UPDATE OR DELETE
ON PADSERVICO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPADS := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDPADSERV,0)   <> NVL(:NEW.CDPADSERV,0)) OR
         (NVL(:OLD.SGPADSERV,0)   <> NVL(:NEW.SGPADSERV,0)) OR
         (NVL(:OLD.DSPADSERV,0)   <> NVL(:NEW.DSPADSERV,0)) OR
         (NVL(:OLD.CDNVPADSERV,0) <> NVL(:NEW.CDNVPADSERV,0)) THEN
         :NEW.DTULTATUPADS := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PADSERVICO', '', 'CDPADSERV='||:OLD.CDPADSERV||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PADSERVICO MODIFY DTULTATUPADS DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_PADSERVICO','4.05.052'); END;
/

