CREATE OR REPLACE TRIGGER USR_ATU_ITEMAUTFDEST_NGD
BEFORE DELETE OR INSERT OR UPDATE OF DTPROGENTAF,
                                     QTPROGENTAF,
                                     VRPREUNIAF,
                                     QTEFETENTRAF,
                                     IDBAIXITMAF

ON ITEMAUTF  FOR EACH ROW
DECLARE
  V_CDARVPROD    VARCHAR2(20) := '';
  V_CDFILIOPELOG VARCHAR2(10) := '';
  V_ERRO         VARCHAR2(300);
BEGIN
   IF DELETING THEN
      SELECT NVL(MAX(CDFILIOPELOG), '')
        INTO V_CDFILIOPELOG
        FROM TIPOOPEROPL
       WHERE CDFILDEST = :OLD.CDFILDEST
         AND IDTIPOOPERSAID IS NOT NULL;
      SELECT NVL(MAX(CDARVPROD), '')
        INTO V_CDARVPROD
        FROM PRODUTO
       WHERE CDPRODUTO = :OLD.CDPRODUTO;
      IF (V_CDFILIOPELOG <> '' AND V_CDARVPROD <> '') THEN
         BEGIN
            UPDATE USR_ITEMAUTFDEST_NGD
               SET TPINTERFACE        = 'E',
                   DTINTERFACEORI     = SYSDATE,
                   DTINTERFACEDEST    = NULL,
                   STATUS             = '1'
             WHERE USR_ITEMAUTFDEST_NGD.CDFILIOPELOG   = V_CDFILIOPELOG
               AND USR_ITEMAUTFDEST_NGD.CDARVPROD      = V_CDARVPROD
               AND USR_ITEMAUTFDEST_NGD.CDFILDEST      = :OLD.CDFILDEST
               AND USR_ITEMAUTFDEST_NGD.DTPROGENTAF    = TO_CHAR(:OLD.DTPROGENTAF, 'YYYYMMDD');
            INSERT
              INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
            VALUES ('USR_ITEMAUTFDEST_NGD', SYSDATE, '0', NULL, V_CDFILIOPELOG||'-'||V_CDARVPROD||'-'||:OLD.CDFILDEST||'-'||TO_CHAR(:OLD.DTPROGENTAF, 'YYYYMMDD'));
         EXCEPTION
            WHEN OTHERS THEN BEGIN
               V_ERRO       := SUBSTR(SQLERRM(SQLCODE), 1, 300);
               INSERT
                 INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
               VALUES ('USR_ITEMAUTFDEST_NGD', SYSDATE, '1', V_ERRO,  V_CDFILIOPELOG||'-'||V_CDARVPROD||'-'||:OLD.CDFILDEST||'-'||TO_CHAR(:OLD.DTPROGENTAF, 'YYYYMMDD'));
            END;
         END;
      END IF;
   ELSIF UPDATING THEN
      IF (NVL(:NEW.IDBAIXITMAF, '1') IN ('3', '2')) AND (NVL(:NEW.IDBAIXITMAF, '1') <> NVL(:OLD.IDBAIXITMAF, '1')) THEN
         SELECT NVL(MAX(CDFILIOPELOG), '')
           INTO V_CDFILIOPELOG
           FROM TIPOOPEROPL
          WHERE CDFILDEST = :NEW.CDFILDEST
            AND IDTIPOOPERSAID IS NOT NULL;
         SELECT NVL(MAX(CDARVPROD), '')
           INTO V_CDARVPROD
           FROM PRODUTO
          WHERE CDPRODUTO = :NEW.CDPRODUTO;
         IF (V_CDFILIOPELOG <> '' AND V_CDARVPROD <> '') THEN
            BEGIN
               UPDATE USR_ITEMAUTFDEST_NGD
                  SET TPINTERFACE        = 'E',
                      DTINTERFACEORI     = SYSDATE,
                      DTINTERFACEDEST    = NULL,
                      STATUS             = '1'
                WHERE USR_ITEMAUTFDEST_NGD.CDFILIOPELOG   = V_CDFILIOPELOG
                  AND USR_ITEMAUTFDEST_NGD.CDARVPROD      = V_CDARVPROD
                  AND USR_ITEMAUTFDEST_NGD.CDFILDEST      = :NEW.CDFILDEST
                  AND USR_ITEMAUTFDEST_NGD.DTPROGENTAF    = TO_CHAR(:OLD.DTPROGENTAF, 'YYYYMMDD');
               INSERT
                 INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
               VALUES ('USR_ITEMAUTFDEST_NGD', SYSDATE, '0', NULL, V_CDFILIOPELOG||'-'||V_CDARVPROD||'-'||:NEW.CDFILDEST||'-'||TO_CHAR(:NEW.DTPROGENTAF, 'YYYYMMDD'));
            EXCEPTION
               WHEN OTHERS THEN BEGIN
                  V_ERRO       := SUBSTR(SQLERRM(SQLCODE), 1, 300);
                  INSERT
                    INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
                  VALUES ('USR_ITEMAUTFDEST_NGD', SYSDATE, '1', V_ERRO,  V_CDFILIOPELOG||'-'||V_CDARVPROD||'-'||:NEW.CDFILDEST||'-'||TO_CHAR(:NEW.DTPROGENTAF, 'YYYYMMDD'));
               END;
            END;
         END IF;
      ELSE
         IF ((NVL(:NEW.DTPROGENTAF, SYSDATE) <> NVL(:OLD.DTPROGENTAF, SYSDATE))  OR
             (NVL(:NEW.QTPROGENTAF, 0)   <> NVL(:OLD.QTPROGENTAF, 0))    OR
             (NVL(:NEW.VRPREUNIAF, 0)    <> NVL(:OLD.VRPREUNIAF, 0))     OR
             (NVL(:NEW.QTEFETENTRAF, 0)  <> NVL(:OLD.QTEFETENTRAF, 0))   OR
             (NVL(:NEW.IDBAIXITMAF, '1') <> NVL(:OLD.IDBAIXITMAF, '1'))) THEN
            :NEW.USR_NGD_INTEGRADO := 'N';
         END IF;
      END IF;
   ELSE
     :NEW.USR_NGD_INTEGRADO   := 'N';
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_ATU_ITEMAUTFDEST_NGD','6.39.030'); END;
/
